module  ASCII
   !! Declarations and initializations for the ASCII control codes 0 to 31, and 127.
   character (len=1), parameter, public :: &
                    NUL = char(0),         & !! The NULL character.
                    SOH = char(1),         & !! Start of Heading.
                    STX = char(2),         & !! Start of Text.
                    ETX = char(3),         & !! Break, or End of Text.
                    EOT = char(4),         & !! End of Transmission.
                    ENQ = char(5),         & !! Enquire.
                    ACK = char(6),         & !! Acknowledge.
                    BEL = char(7),         & !! The bell.
                    BS  = char(8),         & !! The Backspace character.
                    TAB = char(9),         & !! Horizontal Tab (HT).
                    LF  = char(10),        & !! Line Feed.
                    VT  = char(11),        & !! Vertical Tab.
                    FF  = char(12),        & !! Form Feed.
                    CR  = char(13),        & !! Carriage Return.
                    SO  = char(14),        & !! Shift Out.
                    SI  = char(15)           !! Shift In.
   character (len=1), parameter, public :: &
                    DLE = char(16),        & !! Idle.
                    DC1 = char(17),        & !! Device Control 1.
                    DC2 = char(18),        & !! Device Control 2.
                    DC3 = char(19),        & !! Device Control 3.
                    DC4 = char(20),        & !! Device Control 4.
                    NAK = char(21),        & !! Negative Acknowledge.
                    SYN = char(22),        & !! Synchronous idle.
                    ETB = char(23),        & !! End of Transmission Block.
                    CAN = char(24),        & !! Cancel.
                    EM  = char(25),        & !! End of Medium.
                    SUB = char(26),        & !! End of File.
                    ESC = char(27),        & !! The Escape character.
                    FS  = char(28),        & !! File Separator.
                    GS  = char(29),        & !! Group Separator.
                    RS  = char(30),        & !! Record Separator.
                    US  = char(31),        & !! Unit Separator.
                    DEL = char(127)          !! Delete.

end  module  ASCII

