module M1
   implicit  none
   public :: BIN2HEX

contains

!! This function converts the INTEGER argument to a hexadecimal string.  Leading zeros are suppressed.
function BIN2HEX (INT_value) result (Hex)
   integer, intent (in)            :: INT_value
   character (len=8)               :: Hex

   character (len=1)               :: Hex_digit
   integer                         :: Nibble, J, K
   integer, parameter              :: Mask = 15

   K = INT_value
   Hex = " "
   J = len(Hex)

   do
      Nibble = iand(K, Mask)
      select case (Nibble)
         case (:9)
            Hex_digit = char (Nibble + ichar("0") )
         case default
            Hex_digit = char (Nibble - 10 + ichar("A") )
      end  select

      Hex(J:J) = Hex_digit
      J = J - 1
      K = ishft (K, -4)
      if (K == 0) then
         return
      end  if
   end  do

end  function BIN2HEX

end  module  M1