module  CONSTANTS                       !! Declaration selects 18-digit precision, if available,
   implicit  none                       !! otherwise automatically selects 14-digit precision.
   integer, parameter, public :: Extended =   &
              (abs(min(max(selected_real_kind(18), -4), 0) + 2)/2 ) * selected_real_kind(18) + &
              (abs(min(max(selected_real_kind(14), -4), 0) + 2)/2 -                            &
               abs(min(max(selected_real_kind(18), -4), 0) + 2)/2 ) * selected_real_kind(14)
   integer, parameter, public :: Long_Int = &   !! Select 18 or 9-digit integer kind automatically.
              (abs(min(max(selected_int_kind(18), -2), 0) + 1) ) * selected_int_kind (18) +    &
              (abs(min(max(selected_int_kind( 9), -2), 0) + 1) -                               &
               abs(min(max(selected_int_kind(18), -2), 0) + 1) ) * selected_int_kind(9)

   real (kind = Extended), parameter, public :: PI = 3.14159265358979323e0_Extended
   real (kind = Extended), parameter, public :: TWOPI = 6.28318530717958647e0_Extended   !! 2*PI
   real (kind = Extended), parameter, public :: RECIPI = 3.18309886183790672e-1_Extended !! 1/PI
   real (kind = Extended), parameter, public :: PION2 = 1.57079632679489662e0_Extended   !! PI/2
   real (kind = Extended), parameter, public :: SQRTPI = 1.77245385090551602e0_Extended  !! sqrt(PI)
   real (kind = Extended), parameter, public :: sqrt2PI = 2.50662827463100050e0_Extended !! sqrt(2*PI)
   real (kind = Extended), parameter, public :: sqrt2 = 1.41421356237309505e0_Extended   !! sqrt(2)
   real (kind = Extended), parameter, public :: E = 2.71828182845904523e0_Extended
   character (len=26), parameter, public     :: Upper = "ABCDEFGHIJKLMNOPQRSTUVWXYZ",   &
                                                Lower = "abcdefghijklmnopqrstuvwxyz"
   character (len=52), parameter, public  :: Alphabet = Lower // Upper
end  module  CONSTANTS

