module  WEEKDAY_MODULE
   implicit none
   public                          :: TODAY, WEEKDAY

contains

   !! This procedure prints the day, date, month, and year of today's date.
   subroutine  TODAY ( )
      character (len=9), dimension (12), parameter :: Months =       &
                           (/ "January  ", "February ", "March    ", &
                              "April    ", "May      ", "June     ", &
                              "July     ", "August   ", "September", &
                              "October  ", "November ", "December "  /)
      character (len=9), dimension (0:6), parameter   :: Days =      &
                           (/ "Sunday   ", "Monday   ", "Tuesday  ", "Wednesday",   &
                              "Thursday ", "Friday   ", "Saturday "  /)
      integer                      :: Year, Month, Day
      integer, dimension (8)       :: Date_Time

      call date_and_time (values = Date_Time)

      Year     = Date_Time(1)
      Month = Date_Time(2)
      Day      = Date_Time(3)
      if (Year >= 0) then
         write (unit=*, fmt="(2a, i3, tr1, a, i5)" ) "Today is ",    &
            trim ( Days(WEEKDAY(Year, Month, Day)) ),    &
            Day, trim ( Months(Month) ), Year
      else
         write (unit=*, fmt=*) "No date available."
      end  if

   end  subroutine  TODAY

   !! This function returns the current day of the week as an integer (0 = Sunday,
   !! 1 = Monday, etc).
   function  WEEKDAY(Year, Month, Day) result (Day_of_Week)
      integer, intent (in)         :: Year, Month, Day
      integer                      :: Day_of_Week

      integer                      :: DW
      integer, dimension (1:12), parameter :: T = (/  1, 4, 4, 0, 2, 5, 0, 3, 6, 1, 4, 6  /)
      integer                      :: Year2

      Year2 = Year - 1900
      DW = modulo (Year2*5/4 + T(Month) + Day + 6, 7)
      if ( (modulo (Year2, 4) == 0) .and. (Month <= 2) ) then
         if (Year2 > 0) then
            DW = DW - 1                           !! No decrement for 1900.
         end  if
      end  if
      if (DW < 0) then
         DW = DW + 7
      end  if
      Day_of_Week = DW

   end  function  WEEKDAY

end  module  WEEKDAY_MODULE

