module M1
   implicit  none
   public :: SEARCH

contains

!! This function performs a linear search of a list of elements, held in array A,
!! for the given element, held in Key.
function  SEARCH (A, N, Key) result (Position)
      !! INCOMING: A   = an array to be searched;
      !!           N   = the number of elements in the array;
      !!           Key = the element for which the search is conducted.
      !! RETURNS:  the position of the element in the array, if it exists;
      !!           or zero, indicating the element does not exist in the array.

      integer, dimension ( : ), intent (in)  :: A
      integer, intent (in)         :: N
      integer, intent (in)         :: Key
      integer                      :: Position

      integer                      :: J

      do J = 1, N
         if (Key == A(J) ) then
            Position = J
            return                                !! The element is located at position J.
         end  if
      end  do

      Position = 0                                !! The search is unsuccessful.
end  function  SEARCH

!! Figure 10.1  A linear search algorithm

end  module  M1
