module M4
   implicit  none
   public :: SEARCH

contains

!! This procedure searches a hashed array, T, for a given value, Key.  Division hash code
!! generation is used in probing.
function  SEARCH (T, Key) result (Position)
      !! INCOMING: T   = an array (table) of elements T(0) to T(16);
      !!           Key = the element for which the search is conducted.
      !! RETURNS:  the position of the element in the table, if it exists, otherwise negative.

      integer, dimension (0: ), intent (in)  :: T
      integer, intent (in)         :: Key
      integer                      :: Position

      integer                      :: H

      H = modulo(Key, 17)
      if (T(H) /= -1) then
         Position = H                             !! The key was found at position H.
      else
         Position = -1                            !! The key did not exist in the table.
      end  if
end  function  SEARCH

!! Figure 10.4  The essentials of the hash search algorithm

end  module M4
