module M5
   implicit  none
   public :: CREATE

contains

!! This subroutine creates a hashed table T from the elements read in.
!! Linear Searching is used to resolve collisions.
subroutine  CREATE (T)
      !! OUTGOING: T = an array, initialized with values read in.

      integer, dimension (0: ), intent (out) :: T

      integer                      :: Element
      integer, parameter           :: Empty = -1
      integer                      :: J, H

      T = Empty                                   !! Initialize the table to <empty>.
      do J = 1, 10
         print *, "Please type a value for insertion in the hash table:"
         read *, Element
         H = modulo(Element, 17)                  !! Hash the element.
         if (T(H) == Empty) then                  !! The location is empty.
            T(H) = Element                        !! Insert it.
         else                                     !! Perform a linear search for an empty location.
            do
               H = H + 1
               if (H > 16) then                   !! We reached the end of the table . . .
                  H = 0                           !! . . . so wrap around to the beginning of the table.
               end  if
               if (T(H) == Empty) then            !! We have an empty location.
                  exit
               end  if
            end  do
            T(H) = Element                        !! Insert the element.
         end  if
      end  do

end  subroutine  CREATE

!! Figure 10.5  The essentials of hashing, used to create a hashed table.

end  module  M5
