module GROUP
   implicit  none
   public :: HEIGHWAY

contains

!! This subroutine follows a Heighway map to generate Dragon Curves.
!! Start at the left-hand end of the bit string map, and examine the bits one at
!! a time.  For a one-bit in the map, take a left turn.  For a zero bit in the
!! map, take a right turn.
subroutine  HEIGHWAY (Map, Length)
   !! INCOMING: Map    = the bit string defining the shape of the Dragon Curve;
   !!           Length = the number of characters in the string Map (each character stores a bit).

   character (len=*), intent (in)  :: Map
   integer, intent (in)            :: Length

   character (len=1)               :: Route
   character (len=1), parameter    :: Left = "0"
   integer                         :: Direction, I

   Direction = North

   do I = 1, Length
      Route = Map(I:I)
      if (Route == Left) then                     !! Turn left.
         Direction = Direction - 1
      else                                        !! Turn right.
         Direction = Direction + 1
      end  if
      if (Direction < North) then
         Direction = West
      end  if
      if (Direction > West) then
         Direction = North
      end  if
      call MOVE (Direction, Direction, h)
   end  do

end  subroutine  HEIGHWAY

!! Figure 2.21  A subroutine to generate Dragon Curves from the bit string produced by Figure 2.20

end  module  GROUP
