module GROUP
   implicit none
   public                          :: FACTORIAL

contains

   !! This function computes factorial N by a recursive method.
   recursive  function  FACTORIAL (N) result (F)
      !! INCOMING: N = the value whose factorial is required.
      !! RETURNS:  Factorial N.
      integer, intent (in)         :: N
      real                         :: F

      if (N <= 1) then
         F = 1
      else
         F = N * FACTORIAL(N-1)
      end  if

   end  function  FACTORIAL

end  module  GROUP

program  FAC
      use GROUP
      implicit  none
      integer                      :: N
      real                         :: Fx

      print *, "This program calculates factorials."
      print *, "Please type a value: "
      read *, N
      Fx = FACTORIAL (N)
      print *, "The factorial of ", N, " is ", Fx

end  program  FAC

!! Figure 2.3  A complete program for factorials
