module GROUP
   implicit  none
   public :: BASE_CONVERSION

contains

!! This procedure converts a number N in base 10 to another base, New_Base  (2 <= New_Base <= 9).
recursive  subroutine  BASE_CONVERSION (N, New_Base)
   !! INCOMING:   N        = the number in base 10 to be converted to the new base;
   !!             New_Base = the base to which N is to be expressed.

   integer, intent (in)            :: N, New_Base

   if (N <= 0) then
      return
   end  if

   call  BASE_CONVERSION (N/New_Base, New_Base)   !! To perform another division.
   write (unit=*, fmt="(i1)", advance="no" ) modulo (N, New_Base) !! Print one digit in the new base.

end  subroutine  BASE_CONVERSION

!! Figure 2.7  Base conversion algorithm

end  module  GROUP
