module  GROUP
   implicit  none
   public :: IN_ORDER_TRAVERSE

contains

recursive  subroutine  IN_ORDER_TRAVERSE (Current)
      !! INCOMING: Current = a pointer to the root of the tree (initially), or to the root of a sub-tree.
      use  Node_Definition
      type (Node), pointer         :: Current

      if (associated (Current%Left) ) then        !! Try the left-hand path.
         call IN_ORDER_TRAVERSE (Current%Left)
      end  if

      write (unit=*, fmt="(a)", advance="no" ) Current%Symbol

      if (associated (Current%Right) ) then       !! . . . try the right-hand path.
         call IN_ORDER_TRAVERSE (Current%Right)
      end  if

end  subroutine  IN_ORDER_TRAVERSE

!! Figure 3.21  An in-order traversal

end  module GROUP
