module  GROUP
   implicit  none
   public :: PRE_ORDER_TRAVERSE

contains

recursive  subroutine  PRE_ORDER_TRAVERSE (Current)
      !! INCOMING: Current = a pointer to the root of the tree (initially), or to the root of a sub-tree.
      use  Node_Definition
      type (Node), pointer         :: Current

      write (unit=*, fmt="(a)", advance="no" ) Current%Symbol

      if (associated (Current%Left) ) then        !! Try the left-hand path.
         call PRE_ORDER_TRAVERSE (Current%Left)   !! Go deeper into the mire.
      end if

      if (associated (Current%Right) ) then       !! . . . try the right-hand path.
         call PRE_ORDER_TRAVERSE (Current%Right)
      end  if

end  subroutine  PRE_ORDER_TRAVERSE

!! Figure 3.23  A pre-order traversal

end  module  GROUP
