!! This program reads in the characteristics of three electrical circuit components arranged
!! in series, and calculates the overall impedance.  For a given applied sinusoidal voltage,
!! the program calculates the current in complex form and in polar form.
program  IMPEDE
   implicit none
   real                            :: R
   real                            :: L, C
   complex                         :: Z, I
   real                            :: E, f
   real                            :: Theta
   real, parameter                 :: pi = 3.14159

   print *, "Please type the inductance (in Henries):"
   read *, L
   print *, "Please type the capacitance (in Farads):"
   read *, C
   print *, "Please type the resistance (in Ohms):"
   read *, R
   print *, "Please type the applied voltage:"
   read *, E
   print *, "Please type the applied frequency (in Hertz):"
   read *, f
   print *, "The frequency is ", f, " Hz"

   write (unit=*, fmt="(a, f8.2, a)" ) "The applied voltage is ", E, " Volts."

   Z = cmplx (R, 2*pi*f*L - 1/(2*pi*f*C) )
   print *, "The impedance of the circuit is ", Z, " Ohms."
   I = E/Z
   print *, "The current is ", I, " Amps."
   Theta = atan2 (aimag(I), real(I)) * 180 / pi   !! Arctan is in radians, so convert to degrees.
   write (unit=*, fmt="(a, f9.3, a)" )          &
      "The amplitude of the current is ", abs(I), " Amps."
   print *, "The phase is ", Theta, " degrees."
end  program  IMPEDE

!! Figure 4.19  Calculating the current in an electrical network
