   !! This program finds the roots of a quadratic equation of the form ax**2 + bx + c = 0,
   !! including the cases when the roots are complex or equal.
   program  ROOTS
      implicit  none
      real                         :: A, B, C, X1, X2
      complex                      :: CR1, CR2
      real                         :: Disc        !! For the discriminant.

      print *, &
         "This program computes the roots of the quadratic equation Ax**2 + Bx + C = 0."
      print *, "Please type the coefficients A, B, and C:"
      read *, A, B, C
      print *, "The coefficients are: A=", A, " B=", B, " C=", C
      Disc = B**2 - 4*A*C
      if (Disc > 0) then
         print *, "There are two real roots:"
         X1 = (-B + sqrt (Disc) ) / (2*A)
         X2 = (-B - sqrt (Disc) ) / (2*A)
         print *, "X1=", X1, " X2=", X2
      else if (Disc == 0) then
         print *, "There are equal roots: X=", -B/(2*A)
      else
         print *, "The roots are complex:"
         CR1 = (-B + sqrt (cmplx (Disc)) ) / (2*A)!! First root is of the form a+ib;
         CR2 = conjg(CR1)                         !! The second root is of the form a-ib.
         print *, "CR1=", CR1, " CR2=", CR2
      end  if

   end  program  ROOTS

!! Figure 4.3  Computing the roots of a quadratic equation, even when the roots are complex
