!! This program finds the roots of a quadratic equation of the form ax**2 + bx + c = 0.
!! including the cases when the roots are complex or equal.
!! The program uses a more accurate method of computing the roots when the discriminant
!! is close to zero.
program  ROOTS
   implicit  none
   real                            :: A, B, C, X1, X2
   complex                         :: CR1, CR2
   integer, parameter              :: Double = selected_real_kind (14)
   real (kind=Double)              :: Disc        !! Extra precision for the discriminant.

   print *, &
      "This program computes the roots of the quadratic equation Ax**2 + Bx + C = 0."
   print *, "Please type the coefficients A, B, and C:"
   read *, A, B, C
   print *, "The coefficients are: A=", A, " B=", B, " C=", C
   Disc = B*real(B, kind=Double) - 4*A*real(C, kind=Double)
   if (Disc > 0) then
      print *, "There are two real roots:"
      X1 = (-B - sign(1.0, B)*sqrt (Disc) ) / (2*A)
      X2 = C/(A*X1)
      print *, "X1=", X1, " X2=", X2
   else if (Disc == 0) then
      print *, "There are equal roots: X=", -B/(2*A)
   else
      print *, "The roots are complex:"
      CR1 = (-B - sign(1.0, B)*sqrt (cmplx (Disc, kind=kind(Disc))) ) / (2*A)
      CR2 = conjg(CR1)
      print *, "CR1=", CR1, " CR2=", CR2
   end  if

end  program  ROOTS

!! Figure 4.4  A more accurate version of the program to compute the roots of a quadratic equation
