module M2a
   implicit  none
   public :: UPPER_TO_LOWER

contains

!! This function converts upper-case alphabetic characters to lower case.
function  UPPER_TO_LOWER (Word) result (Translated_Text)

   character (len=*), intent (in)  :: Word

   character (len=len(Word))       :: Translated_Text

   character (len=26), parameter   :: Upper = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
   character (len=26), parameter   :: Lower = "abcdefghijklmnopqrstuvwxyz"
   integer                         :: J, K, L

   Translated_Text = Word
   J = 0
   do
      if (J+1 > len(Translated_Text)) then
         return                                   !! No more characters in Translated_Text.
      end  if
      K = scan (Word(J+1: ), Upper)               !! Search Word for any upper-case letters.
      if (K == 0) then
         return                                   !! No more upper-case letters.
      end  if
      J = K + J                                   !! The true position of the character.
      !! We have an upper-case letter at position J in Translated_Text.
      L = index(Upper, Word(J:J))                 !! Look for that upper-case letter in Upper.
      Translated_Text(J:J) = Lower(L:L)           !! Replace it with the equivalent lower-case letter.
   end  do

end  function  UPPER_TO_LOWER

end  module  M2a
