module M4
   implicit  none
   public :: SEARCH_CLASSIC

contains

   !! This function implements the standard scan-first-character string search.
   function  SEARCH_CLASSIC (String, Pattern) result (Position)
      !! INCOMING: String  = the string to be searched;
      !!           Pattern = what we are searching for in String.
      !! RETURNS:  The position of Pattern in the String, if successful; or
      !!           zero, indicating an unsuccessful search.
      character (len=*), intent (in) :: String, Pattern

      integer                        :: Position

      integer                        :: LP, LS, J

      LP = len (Pattern)
      LS = len (String)

      do J = 1, LS-LP+1
         if (String (J: J+LP-1) == Pattern) then  !! The search was successful.
            Position = J                          !! Return the position of the first character.
            return
         end  if
      end  do

      Position = 0                                !! The search was unsuccessful.
   end  function  SEARCH_CLASSIC

!! Figure 6.4  The classic string search

end  module  M4
