   module  DT

      type, public                 :: Customer_Outline
         character (len=20)        :: Name
         character (len=20)        :: Street
         character (len=20)        :: Suburb
         character (len=4)         :: Postcode
         character (len=9)         :: Home_Tel_No
         character (len=9)         :: Work_Tel_No
      end  type Customer_Outline

   end  module DT

   module GROUP
      implicit none
      public                       :: ALTER

   contains

      !! This subroutine prompts the user to check and/or correct data about a client.
      subroutine  ALTER (Category, Item)
         !! INCOMING: Category = the category (name, street, etc).
         !!           Item     = the value of a client field (his name, street, etc).
         !! OUTGOING: Item     = an updated value.
         character (len=*), intent (in)   :: Category
         character (len=*), intent (in out) :: Item

         character (len=20)        :: Data
         character (len=1)         :: Response

         print *, "Do you want to alter the " // Category // "?  Reply Y or N:"
         read (unit=*, fmt="(a1)" ) Response
         if ( (Response == "Y" ) .or. (Response == "y" ) ) then
            print *, "Please type the new " // Category // ":"
            read (unit=*, fmt="(a20)" ) Data
            Item = adjustl(Data)
            write (unit=*, fmt="(//a)" ) Item // " has been entered in " // Category // "."
         end  if

      end  subroutine  ALTER

   end  module  GROUP

   program  SHOW
      use  DT
      use  GROUP
      implicit  none

      type (Customer_Outline)      :: Customer
      integer                      :: Ref_No

      open (unit=9, file="CLIENTS.DAT", form="unformatted", access="direct",  &
         action="readwrite", recl=82, status="old" )

      print *, "This program alters details of a customer."
      print *, "Please type the reference number of the customer:"
      read (unit=*, fmt=*) Ref_No

      read (unit=9, rec=Ref_No) Customer

      write (unit=*, fmt="(///a)" ) Customer%Name
      print *, Customer%Street
      print *, Customer%Suburb, Customer%Postcode
      print *, Customer%Home_Tel_No, " ", Customer%Work_Tel_No

      call ALTER ("name", Customer%Name)
      call ALTER ( "street", Customer%Street)
      call ALTER ( "suburb", Customer%Suburb)
      call ALTER ( "postcode", Customer%Postcode)
      call ALTER ( "home telephone number", Customer%Home_Tel_No)
      call ALTER ( "work telephone number",  Customer%Work_Tel_No)

      write (unit=9, rec=Ref_No) Customer

   end  program  SHOW

!! Figure 7.3  Reading a random access unformatted file
